require 'fileutils'

TmpDir = "/tmp/autocommit_#{$$}_#{rand 32768}_#{Time.now.to_i}/"

def create *files
  files.each {|file|
    File.open tmp(file), "w" do
    end
  }
end

def remove *files
  files.each {|file|
    File.delete tmp(file)
  }
end

class Move
  def initialize file
    @file = file
  end
  def to dest
    File.rename tmp(@file), tmp(dest)
  end
end

def move *files
  Move.new *files
end

def modify file
  File.open tmp(file), "r+" do |f|
    f.puts "Some random garbage #{rand 1234567890}"
  end
end

def mkdir *dirs
  dirs.each do |dir|
    FileUtils.mkpath tmp(dir)
  end
end

def tmp file
  File.join TmpDir, file
end

RSpec.configure do |config|
  config.before :each do
    wipe_tmp_dir
    Dir.mkdir TmpDir
  end

  config.after :each do
    wipe_tmp_dir
  end
end

def wipe_tmp_dir
  FileUtils.rm_rf TmpDir
end
